'use strict';

var React = require('react');
var useChannelSettings = require('../../chunks/bundle-DdzMtmJV.js');
var LocalizationContext = require('../../chunks/bundle-DcN1PHcN.js');
var ui_ChannelAvatar = require('../../ui/ChannelAvatar.js');
var ui_TextButton = require('../../ui/TextButton.js');
var ui_Label = require('../../chunks/bundle-lBm_66LS.js');
var ChannelSettings_components_EditDetailsModal = require('./EditDetailsModal.js');
var useSendbird = require('../../chunks/bundle-DVLcUvUT.js');
var index = require('../../chunks/bundle-BfwsoZ_f.js');
require('../../chunks/bundle-bHxwJtYj.js');
require('../../chunks/bundle-CrDIwW5W.js');
require('../../chunks/bundle-BCTa9jYZ.js');
require('@sendbird/chat/groupChannel');
require('../../chunks/bundle-CSL84Mpm.js');
require('../../chunks/bundle-CGLD5gdu.js');
require('../../chunks/bundle-CWKemlba.js');
require('../../chunks/bundle-CTbRos2s.js');
require('../../chunks/bundle-rjBp4QCu.js');
require('../../chunks/bundle-B8yyLIhC.js');
require('../../chunks/bundle-kff9Zj9O.js');
require('../../ui/ImageRenderer.js');
require('../../chunks/bundle-BDCiiker.js');
require('../../ui/Icon.js');
require('../../chunks/bundle-C7qr3IUb.js');
require('../../chunks/bundle-DsHHiIba.js');
require('../../chunks/bundle-Cg_wfVMn.js');
require('react-dom');
require('../../chunks/bundle-DcUoqLZn.js');
require('../../ui/IconButton.js');
require('../../ui/Button.js');
require('../../ui/Input.js');
require('@sendbird/chat');
require('@sendbird/chat/openChannel');
require('../../utils/message/getOutgoingMessageState.js');
require('../../chunks/bundle-DxLfx2gA.js');
require('../../chunks/bundle-CY1y7JJW.js');
require('../../chunks/bundle-vOqLpYwi.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

var ChannelProfile = function () {
    var _a, _b, _c;
    var state = useSendbird.useSendbird().state;
    var channel = useChannelSettings.useChannelSettings().state.channel;
    var stringSet = React.useContext(LocalizationContext.LocalizationContext).stringSet;
    var _d = React.useState(false), showModal = _d[0], setShowModal = _d[1];
    var userId = (_a = state === null || state === void 0 ? void 0 : state.config) === null || _a === void 0 ? void 0 : _a.userId;
    var theme = ((_b = state === null || state === void 0 ? void 0 : state.config) === null || _b === void 0 ? void 0 : _b.theme) || 'light';
    var isOnline = (_c = state === null || state === void 0 ? void 0 : state.config) === null || _c === void 0 ? void 0 : _c.isOnline;
    var disabled = !isOnline;
    var channelName = React.useMemo(function () {
        if (!(channel === null || channel === void 0 ? void 0 : channel.name) && !(channel === null || channel === void 0 ? void 0 : channel.members))
            return stringSet.NO_TITLE;
        if (index.isDefaultChannelName(channel))
            return ((channel === null || channel === void 0 ? void 0 : channel.members) || []).map(function (member) { return member.nickname || stringSet.NO_NAME; }).join(', ');
        return channel.name;
    }, [channel === null || channel === void 0 ? void 0 : channel.name, channel === null || channel === void 0 ? void 0 : channel.joinedMemberCount]);
    return (React__default.default.createElement("div", { className: "sendbird-channel-profile" },
        React__default.default.createElement("div", { className: "sendbird-channel-profile--inner" },
            React__default.default.createElement("div", { className: "sendbird-channel-profile__avatar" },
                React__default.default.createElement(ui_ChannelAvatar, { channel: channel, userId: userId, theme: theme, width: 80, height: 80 })),
            React__default.default.createElement(ui_Label.Label, { className: "sendbird-channel-profile__title", type: ui_Label.LabelTypography.SUBTITLE_2, color: ui_Label.LabelColors.ONBACKGROUND_1 }, channelName),
            React__default.default.createElement(ui_TextButton, { disabled: disabled, className: "sendbird-channel-profile__edit", onClick: function () {
                    if (disabled) {
                        return;
                    }
                    setShowModal(true);
                }, disableUnderline: true },
                React__default.default.createElement(ui_Label.Label, { type: ui_Label.LabelTypography.BUTTON_1, color: disabled ? ui_Label.LabelColors.ONBACKGROUND_2 : ui_Label.LabelColors.PRIMARY }, stringSet.CHANNEL_SETTING__PROFILE__EDIT)),
            showModal && (React__default.default.createElement(ChannelSettings_components_EditDetailsModal, { onCancel: function () { return setShowModal(false); }, onSubmit: function () { return setShowModal(false); } })))));
};

module.exports = ChannelProfile;
//# sourceMappingURL=ChannelProfile.js.map
