'use strict';

var React = require('react');
var useChannelSettings = require('../../chunks/bundle-DdzMtmJV.js');
var LocalizationContext = require('../../chunks/bundle-DcN1PHcN.js');
var ui_Badge = require('../../ui/Badge.js');
var ui_Label = require('../../chunks/bundle-lBm_66LS.js');
var ui_Icon = require('../../ui/Icon.js');
var MemberList = require('../../chunks/bundle-Cij380So.js');
require('../../chunks/bundle-bHxwJtYj.js');
require('../../chunks/bundle-CrDIwW5W.js');
require('../../chunks/bundle-BCTa9jYZ.js');
require('@sendbird/chat/groupChannel');
require('../../chunks/bundle-CSL84Mpm.js');
require('../../chunks/bundle-CGLD5gdu.js');
require('../../chunks/bundle-CWKemlba.js');
require('../../chunks/bundle-CTbRos2s.js');
require('../../chunks/bundle-DVLcUvUT.js');
require('@sendbird/chat');
require('@sendbird/chat/openChannel');
require('../../chunks/bundle-rjBp4QCu.js');
require('../../chunks/bundle-B8yyLIhC.js');
require('../../ui/Button.js');
require('../../chunks/bundle-CAGL0mVD.js');
require('../../chunks/bundle-ClGbrizJ.js');
require('react-dom');
require('../../ui/SortByRow.js');
require('../../ui/IconButton.js');
require('../../chunks/bundle-BfwsoZ_f.js');
require('../../utils/message/getOutgoingMessageState.js');
require('../../chunks/bundle-DxLfx2gA.js');
require('../../chunks/bundle-CY1y7JJW.js');
require('../../chunks/bundle-vOqLpYwi.js');
require('../../ui/UserListItem.js');
require('../../chunks/bundle-kff9Zj9O.js');
require('../../ui/ImageRenderer.js');
require('../../chunks/bundle-BDCiiker.js');
require('../../ui/MutedAvatarOverlay.js');
require('../../ui/Checkbox.js');
require('../../ui/UserProfile.js');
require('../../sendbirdSelectors.js');
require('../../chunks/bundle-e1RcyXEh.js');
require('../../chunks/bundle-Cg_wfVMn.js');
require('../../chunks/bundle-DcUoqLZn.js');
require('../../chunks/bundle-C19bOC0u.js');
require('../../chunks/bundle-HgxzcOKL.js');
require('@sendbird/chat/message');
require('@sendbird/uikit-tools');
require('../../chunks/bundle-Bs2ljYon.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

var kFormatter = function (num) {
    return Math.abs(num) > 999
        ? "".concat((Math.abs(num) / 1000).toFixed(1), "K")
        : num;
};
var UserPanel = function () {
    var stringSet = LocalizationContext.useLocalization().stringSet;
    var _a = React.useState(false), showAccordion = _a[0], setShowAccordion = _a[1];
    var channel = useChannelSettings.useChannelSettings().state.channel;
    return (React__default.default.createElement("div", { className: 'sendbird-channel-settings__user-panel' },
        React__default.default.createElement("div", { className: [
                'sendbird-channel-settings__panel-item',
                'sendbird-channel-settings__members',
            ].join(' '), role: "switch", "aria-checked": showAccordion, onKeyDown: function () { return setShowAccordion(!showAccordion); }, onClick: function () { return setShowAccordion(!showAccordion); }, tabIndex: 0 },
            React__default.default.createElement(ui_Icon.default, { className: "sendbird-channel-settings__panel-icon-left", type: ui_Icon.IconTypes.MEMBERS, fillColor: ui_Icon.IconColors.PRIMARY, height: "24px", width: "24px" }),
            React__default.default.createElement(ui_Label.Label, { type: ui_Label.LabelTypography.SUBTITLE_1, color: ui_Label.LabelColors.ONBACKGROUND_1 },
                stringSet.CHANNEL_SETTING__MEMBERS__TITLE,
                React__default.default.createElement(ui_Badge, { className: 'sendbird-channel-settings__badge', count: channel ? kFormatter(channel === null || channel === void 0 ? void 0 : channel.memberCount) : '' })),
            React__default.default.createElement(ui_Icon.default, { className: [
                    'sendbird-channel-settings__panel-icon-right',
                    'sendbird-channel-settings__panel-icon--chevron',
                    (showAccordion ? 'sendbird-channel-settings__panel-icon--open' : ''),
                ].join(' '), type: ui_Icon.IconTypes.CHEVRON_RIGHT, height: "24px", width: "24px" })),
        showAccordion && (React__default.default.createElement(MemberList.MemberList, null))));
};

module.exports = UserPanel;
//# sourceMappingURL=UserPanel.js.map
