'use strict';

var _tslib = require('../../chunks/bundle-bHxwJtYj.js');
var React = require('react');
var Thread_components_ThreadListItem = require('./ThreadListItem.js');
var Channel_utils_compareMessagesForGrouping = require('../../Channel/utils/compareMessagesForGrouping.js');
var dateFns = require('date-fns');
var Message_context = require('../../Message/context.js');
var resolvedReplyType = require('../../chunks/bundle-0VXVESR_.js');
var ThreadProvider = require('../../chunks/bundle-CBRiA6WQ.js');
var useSendbird = require('../../chunks/bundle-DVLcUvUT.js');
var LocalizationContext = require('../../chunks/bundle-DcN1PHcN.js');
require('../../chunks/bundle-BNyKt7U9.js');
require('../../chunks/bundle-vOqLpYwi.js');
require('../../chunks/bundle-B8yyLIhC.js');
require('../../ui/DateSeparator.js');
require('../../chunks/bundle-DsHHiIba.js');
require('../../chunks/bundle-lBm_66LS.js');
require('../../chunks/bundle-rjBp4QCu.js');
require('../../chunks/bundle-XZ6oPmao.js');
require('../../chunks/bundle-Cg_wfVMn.js');
require('react-dom');
require('../../chunks/bundle-CWKemlba.js');
require('../../chunks/bundle-DcUoqLZn.js');
require('../../ui/IconButton.js');
require('../../ui/Button.js');
require('../../ui/Icon.js');
require('../../chunks/bundle-CSL84Mpm.js');
require('../../chunks/bundle-iXYg1WCn.js');
require('../../chunks/bundle-BfwsoZ_f.js');
require('@sendbird/chat/groupChannel');
require('../../utils/message/getOutgoingMessageState.js');
require('../../chunks/bundle-DxLfx2gA.js');
require('../../chunks/bundle-CY1y7JJW.js');
require('../../chunks/bundle-BCTa9jYZ.js');
require('../../ui/FileViewer.js');
require('../../hooks/useModal.js');
require('../../chunks/bundle-CrDIwW5W.js');
require('@sendbird/chat');
require('@sendbird/chat/openChannel');
require('../../chunks/bundle-kff9Zj9O.js');
require('../../ui/ImageRenderer.js');
require('../../chunks/bundle-BDCiiker.js');
require('../../chunks/bundle-CzH-slJQ.js');
require('@sendbird/uikit-tools');
require('../../chunks/bundle-qMFessk5.js');
require('../../chunks/bundle-DqS0b7mw.js');
require('../../chunks/bundle-FVJAh-zj.js');
require('../../chunks/bundle-BJVsKj8Z.js');
require('../../ui/MessageInput.js');
require('../../chunks/bundle-BVvNMYPW.js');
require('dompurify');
require('../../chunks/bundle-BkM3gvpZ.js');
require('../../chunks/bundle-2GbPVyMk.js');
require('../../chunks/bundle-D_qhuYi9.js');
require('../../chunks/bundle-j9d_a2oN.js');
require('../context/types.js');
require('../../chunks/bundle-ClGbrizJ.js');
require('../../ui/SortByRow.js');
require('../../ui/MessageItemReactionMenu.js');
require('../../ui/ReactionButton.js');
require('../../chunks/bundle-Cnw2-Jv9.js');
require('../../chunks/bundle-DBfn8v_s.js');
require('../../ui/Loader.js');
require('../../chunks/bundle-DbxOf2R0.js');
require('../../chunks/bundle-BXs1Q9r8.js');
require('../../ui/EmojiReactions.js');
require('../../ui/ReactionBadge.js');
require('../../ui/BottomSheet.js');
require('../../ui/UserListItem.js');
require('../../chunks/bundle-CTbRos2s.js');
require('../../ui/MutedAvatarOverlay.js');
require('../../ui/Checkbox.js');
require('../../ui/UserProfile.js');
require('../../sendbirdSelectors.js');
require('../../chunks/bundle-e1RcyXEh.js');
require('../../ui/Tooltip.js');
require('../../ui/TooltipWrapper.js');
require('../../chunks/bundle-D8ZU5Tpa.js');
require('../../ui/MobileMenu.js');
require('../../chunks/bundle-tO_sLFMv.js');
require('@sendbird/chat/message');
require('../../chunks/bundle-Br-P6K7i.js');
require('../../chunks/bundle-gO1LxUb8.js');
require('../../chunks/bundle-DGnoI4PY.js');
require('../../ui/OGMessageItemBody.js');
require('../../chunks/bundle-6nGIhFDY.js');
require('../../ui/MentionLabel.js');
require('../../ui/LinkLabel.js');
require('../../ui/TextMessageItemBody.js');
require('../../ui/FileMessageItemBody.js');
require('../../ui/TextButton.js');
require('../../ui/VoiceMessageItemBody.js');
require('../../ui/ProgressBar.js');
require('../../VoicePlayer/useVoicePlayer.js');
require('../../chunks/bundle-CxkC0X_8.js');
require('../../VoiceRecorder/context.js');
require('../../ui/PlaybackTime.js');
require('../../ui/ThumbnailMessageItemBody.js');
require('../../chunks/bundle-CqGDJCGV.js');
require('../../ui/UnknownMessageItemBody.js');
require('../../ui/TemplateMessageItemBody.js');
require('../../chunks/bundle-CN-Q2nDp.js');
require('../../ui/FallbackTemplateMessageItemBody.tsx.js');
require('../../ui/LoadingTemplateMessageItemBody.tsx.js');
require('../../ui/MessageFeedbackFailedModal.js');
require('../../chunks/bundle-BF92QIXA.js');
require('../../chunks/bundle-D5p7gTdQ.js');
require('../../Message/hooks/useDirtyGetMentions.js');
require('../../chunks/bundle-p6OKUiqX.js');
require('../../chunks/bundle-HgxzcOKL.js');
require('../../chunks/bundle-CGLD5gdu.js');
require('../../chunks/bundle-C-CraE0i.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);

function ThreadList(_a) {
    var className = _a.className, _b = _a.renderMessage, renderMessage = _b === void 0 ? function (props) { return React__default.default.createElement(Thread_components_ThreadListItem, _tslib.__assign({}, props)); } : _b, renderCustomSeparator = _a.renderCustomSeparator, scrollRef = _a.scrollRef, scrollBottom = _a.scrollBottom;
    var config = useSendbird.useSendbird().state.config;
    var stringSet = LocalizationContext.useLocalization().stringSet;
    var userId = config.userId;
    var _c = ThreadProvider.useThread().state, currentChannel = _c.currentChannel, allThreadMessages = _c.allThreadMessages, localThreadMessages = _c.localThreadMessages;
    return (React__default.default.createElement("div", { className: "sendbird-thread-list ".concat(className) },
        allThreadMessages.map(function (message, idx) {
            var _a;
            var isByMe = ((_a = message === null || message === void 0 ? void 0 : message.sender) === null || _a === void 0 ? void 0 : _a.userId) === userId;
            var prevMessage = allThreadMessages[idx - 1];
            var nextMessage = allThreadMessages[idx + 1];
            // eslint-disable-next-line no-constant-condition
            var _b = Channel_utils_compareMessagesForGrouping.compareMessagesForGrouping(prevMessage, message, nextMessage, stringSet, currentChannel, resolvedReplyType.getCaseResolvedReplyType(config.groupChannel.replyType).upperCase)
                , chainTop = _b[0], chainBottom = _b[1];
            var hasSeparator = !((prevMessage === null || prevMessage === void 0 ? void 0 : prevMessage.createdAt) > 0 && (dateFns.isSameDay(message === null || message === void 0 ? void 0 : message.createdAt, prevMessage === null || prevMessage === void 0 ? void 0 : prevMessage.createdAt)));
            var handleScroll = function () {
                var current = scrollRef === null || scrollRef === void 0 ? void 0 : scrollRef.current;
                if (current && scrollBottom) {
                    var bottom = current.scrollHeight - current.scrollTop - current.offsetHeight;
                    if (scrollBottom < bottom) {
                        current.scrollTop += bottom - scrollBottom;
                    }
                }
            };
            return (React__default.default.createElement(Message_context.MessageProvider, { message: message, isByMe: isByMe, key: message === null || message === void 0 ? void 0 : message.messageId }, renderMessage({
                message: message,
                chainTop: chainTop,
                chainBottom: chainBottom,
                hasSeparator: hasSeparator,
                renderCustomSeparator: renderCustomSeparator,
                handleScroll: handleScroll,
            })));
        }),
        localThreadMessages.map(function (message) {
            var _a;
            var isByMe = ((_a = message === null || message === void 0 ? void 0 : message.sender) === null || _a === void 0 ? void 0 : _a.userId) === userId;
            var handleScroll = function () {
                var current = scrollRef === null || scrollRef === void 0 ? void 0 : scrollRef.current;
                if (current) {
                    var bottom = current.scrollHeight - current.scrollTop - current.offsetHeight;
                    if (scrollBottom < bottom) {
                        current.scrollTop += bottom - scrollBottom;
                    }
                }
            };
            return (React__default.default.createElement(Message_context.MessageProvider, { message: message, isByMe: isByMe, key: message === null || message === void 0 ? void 0 : message.messageId }, renderMessage({
                message: message,
                hasSeparator: false,
                renderCustomSeparator: renderCustomSeparator,
                handleScroll: handleScroll,
            })));
        })));
}

module.exports = ThreadList;
//# sourceMappingURL=ThreadList.js.map
