import type { GroupChannel } from '@sendbird/chat/groupChannel';
import type { MessageSearchQueryParams } from '@sendbird/chat/lib/__definition';
import type { SendbirdError } from '@sendbird/chat';
import type { Logger, SdkStore } from '../../../../lib/Sendbird/types';
import { CoreMessageType } from '../../../../utils';
interface MainProps {
    currentChannel: GroupChannel | null;
    channelUrl: string;
    requestString?: string;
    messageSearchQuery?: MessageSearchQueryParams;
    onResultLoaded?: (messages?: Array<CoreMessageType>, error?: SendbirdError) => void;
}
interface ToolProps {
    sdk: SdkStore['sdk'];
    logger: Logger;
}
declare function useGetSearchedMessages({ currentChannel, channelUrl, requestString, messageSearchQuery, onResultLoaded }: MainProps, { sdk, logger }: ToolProps): void;
export default useGetSearchedMessages;
