import type { GroupChannel } from '@sendbird/chat/groupChannel';
import { MessageSearchQuery } from '@sendbird/chat/message';
import { ClientSentMessages } from '../../../../types';
import { type MessageSearchState } from '../MessageSearchProvider';
declare const useMessageSearch: () => {
    state: MessageSearchState;
    actions: {
        setCurrentChannel: (channel: GroupChannel) => void;
        setChannelInvalid: () => void;
        getSearchedMessages: (messages: ClientSentMessages[], createdQuery: MessageSearchQuery) => void;
        setQueryInvalid: () => void;
        startMessageSearch: () => void;
        startGettingSearchedMessages: (query: MessageSearchQuery) => void;
        getNextSearchedMessages: (messages: ClientSentMessages[]) => void;
        resetSearchString: () => void;
        setSelectedMessageId: (messageId: number) => () => void;
        handleRetryToConnect: () => void;
        setRetryCount: () => void;
    };
};
export default useMessageSearch;
