import { GroupChannel } from '@sendbird/chat/groupChannel';
import { UserMessageCreateParams } from '@sendbird/chat/message';
import { User } from '@sendbird/chat';
import type { Logger } from '../../../../lib/Sendbird/types';
import { SBUGlobalPubSub } from '../../../../lib/pubSub/topics';
import { SendableMessageType } from '../../../../utils';
export type OnBeforeSendUserMessageType = (message: string, quoteMessage?: SendableMessageType) => UserMessageCreateParams;
interface DynamicProps {
    isMentionEnabled: boolean;
    currentChannel: GroupChannel | null;
    onBeforeSendUserMessage?: OnBeforeSendUserMessageType;
    sendMessageStart: (message: SendableMessageType) => void;
    sendMessageFailure: (message: SendableMessageType) => void;
}
interface StaticProps {
    logger: Logger;
    pubSub: SBUGlobalPubSub;
}
export type SendMessageParams = {
    message: string;
    quoteMessage?: SendableMessageType;
    mentionTemplate?: string;
    mentionedUsers?: Array<User>;
};
export default function useSendUserMessageCallback({ isMentionEnabled, currentChannel, onBeforeSendUserMessage, sendMessageStart, sendMessageFailure, }: DynamicProps, { logger, pubSub, }: StaticProps): (props: SendMessageParams) => void;
export {};
