import { GroupChannel } from '@sendbird/chat/groupChannel';
import { FileMessageCreateParams } from '@sendbird/chat/message';
import type { Logger } from '../../../../lib/Sendbird/types';
import { SBUGlobalPubSub } from '../../../../lib/pubSub/topics';
import { SendableMessageType } from '../../../../utils';
interface DynamicParams {
    currentChannel: GroupChannel | null;
    onBeforeSendVoiceMessage?: (file: File, quoteMessage?: SendableMessageType) => FileMessageCreateParams;
    sendMessageStart: (message: SendableMessageType) => void;
    sendMessageFailure: (message: SendableMessageType) => void;
}
interface StaticParams {
    logger: Logger;
    pubSub: SBUGlobalPubSub;
}
type FuncType = (file: File, duration: number, quoteMessage: SendableMessageType) => void;
export declare const useSendVoiceMessageCallback: ({ currentChannel, onBeforeSendVoiceMessage, sendMessageStart, sendMessageFailure, }: DynamicParams, { logger, pubSub, }: StaticParams) => FuncType;
export default useSendVoiceMessageCallback;
