import { User } from '@sendbird/chat';
import { GroupChannel } from '@sendbird/chat/groupChannel';
import type { Logger } from '../../../../lib/Sendbird/types';
import { SBUGlobalPubSub } from '../../../../lib/pubSub/topics';
import { SendableMessageType } from '../../../../utils';
interface DynamicProps {
    currentChannel: GroupChannel | null;
    isMentionEnabled?: boolean;
    onMessageUpdated: (currentChannel: GroupChannel, message: SendableMessageType) => void;
}
interface StaticProps {
    logger: Logger;
    pubSub: SBUGlobalPubSub;
}
type CallbackParams = {
    messageId: number;
    message: string;
    mentionedUsers?: User[];
    mentionTemplate?: string;
};
export default function useUpdateMessageCallback({ currentChannel, isMentionEnabled, onMessageUpdated, }: DynamicProps, { logger, pubSub, }: StaticProps): (props: CallbackParams) => void;
export {};
